package ap;

import ap.proof.ExhaustiveProver
import ap.parser.PlainTranslator

object CmdlMain {

  private def printGreeting = {
    println("________       _____")                                 
    println("___  __ \\_________(_)________________________________")
    println("__  /_/ /_  ___/_  /__  __ \\  ___/  _ \\_  ___/_  ___/")
    println("_  ____/_  /   _  / _  / / / /__ /  __/(__  )_(__  )")
    println("/_/     /_/    /_/  /_/ /_/\\___/ \\___//____/ /____/")  
  }
  
  def main(args: Array[String]) : unit = {
    printGreeting
    println
    
    args match {
      case Array() => println("No inputs given, exiting")
      case Array(filename) => prove(filename)
    }
  }
  
  private def prove(filename : String) : unit = {
    println("Loading file " + filename + " ...")
    val reader = new java.io.FileReader(filename)
    
    val goal = try { PlainTranslator(reader) } catch {
      case e : Throwable => {
        println("ERROR: " + e.getMessage)
        System exit 1
        null // necessary to turn the type of the try-block into Goal
      }
    }
    reader.close
    
//    println(goal)
    
    println("Proving ...")
    val tree = ExhaustiveProver(goal)
    println("Resulting constraint:")
    println(tree.closingConstraint)
    
//    println(tree)
  }
}
